using System;
using System.Text;
using Windows.Globalization;
using Windows.Globalization.DateTimeFormatting;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///   3
    /// </summary>
    public sealed partial class SamplePage3 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SamplePage3()

        /// <summary>
        /// 
        /// </summary>
        public SamplePage3()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ǥ ư Ŭ óϱ - showResultButton_Click(sender, e)

        /// <summary>
        ///  ǥ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void showResultButton_Click(object sender, RoutedEventArgs e)
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine
            (
                "Ϻ ȣ ޷    ʽϴ. ־   ̿  ˴ϴ : "
            );

            stringBuilder.AppendLine();

            Calendar calendar = new Calendar
            (
                new[] { "en-US" },
                CalendarIdentifiers.Japanese,
                ClockIdentifiers.TwentyFourHour
            );

            for(calendar.Era = calendar.FirstEra; true; calendar.AddYears(1))
            {
                stringBuilder.AppendLine($" {calendar.EraAsString()} : {calendar.NumberOfYearsInThisEra}");

                for(calendar.Year = calendar.FirstYearInThisEra; true; calendar.AddYears(1))
                {
                    calendar.Month      = calendar.FirstMonthInThisYear;
                    calendar.Day        = calendar.FirstDayInThisMonth;
                    calendar.Period     = calendar.FirstPeriodInThisDay;
                    calendar.Hour       = calendar.FirstHourInThisPeriod;
                    calendar.Minute     = 0;
                    calendar.Second     = 0;
                    calendar.Nanosecond = 0;

                    if(calendar.Year % 1000 == 0)
                    {
                        stringBuilder.AppendLine();
                    }
                    else if(calendar.Year % 10 == 0)
                    {
                        stringBuilder.Append(".");
                    }

                    if(calendar.Year == calendar.LastYearInThisEra)
                    {
                        break;
                    }
                }

                stringBuilder.AppendLine();

                if(calendar.Era == calendar.LastEra)
                {
                    break;
                }
            }

            stringBuilder.AppendLine();

            stringBuilder.AppendLine("Ϸ ð   ʽϴ. 2012 11 4 ̱ ޷ ϱ  ð ǥ ð ȯ˴ϴ :\n");

            DateTimeFormatter formatter = new DateTimeFormatter("longdate");

            Calendar startCalendar = new Calendar
            (
                new string[] { "en-US" },
                CalendarIdentifiers.Gregorian,
                ClockIdentifiers.TwentyFourHour,
                "America/Los_Angeles"
            );

            DateTime targetDate = new DateTime(2012, 11, 4, 9, 0, 0, DateTimeKind.Utc);

            startCalendar.SetDateTime(targetDate);

            Calendar endCalendar = startCalendar.Clone();

            startCalendar.AddDays(-1);

            endCalendar.AddDays(1);

            while(startCalendar.Day <= endCalendar.Day)
            {
                DateTimeOffset date = startCalendar.GetDateTime();

                stringBuilder.AppendFormat("{0} : {1}ð\n", formatter.Format(date), startCalendar.NumberOfHoursInThisPeriod);

                Calendar nextCalendar = startCalendar.Clone();

                nextCalendar.AddDays(1);

                for(startCalendar.Hour = startCalendar.FirstHourInThisPeriod; true; startCalendar.AddHours(1))
                {
                    stringBuilder.AppendFormat("{0} ", startCalendar.HourAsPaddedString(2));

                    if(startCalendar.Day == nextCalendar.Day && startCalendar.Period == nextCalendar.Period)
                    {
                        break;
                    }
                }

                stringBuilder.AppendLine();
            }

            this.resultTextBlock.Text = stringBuilder.ToString();
        }

        #endregion
    }
}