using System.Text;
using Windows.Globalization;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///   4
    /// </summary>
    public sealed partial class SamplePage4 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SamplePage4()

        /// <summary>
        /// 
        /// </summary>
        public SamplePage4()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ǥ ư Ŭ óϱ - showResultButton_Click(sender, e)

        /// <summary>
        ///  ǥ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void showResultButton_Click(object sender, RoutedEventArgs e)
        {
            Calendar calendar1 = new Calendar();
            Calendar calendar2 = new Calendar(new[] { "ar-SA-u-ca-gregory-nu-Latn"   });
            Calendar calendar3 = new Calendar(new[] { "he-IL-u-nu-arab"              });
            Calendar calendar4 = new Calendar(new[] { "he-IL-u-ca-hebrew-co-phonebk" });

            this.resultTextBlock.Text =
                ReportCalendarData
                (
                    calendar1,
                    " Ʈ ޷ ü"
                ) +
                ReportCalendarData
                (
                    calendar2,
                    "ƶ, ׷  ƾ  ü(ar-SA-ca-gregory-nu-Latn)  ޷ ü"
                ) +
                ReportCalendarData
                (
                    calendar3,
                    "긮, ش  ⺻ ޷  ƶ  ü(he-IL-u-nu-arab)  ޷ ü"
                ) +
                ReportCalendarData
                (
                    calendar4,
                    "긮, 긮 ޷, ش   ⺻  ü  ȭȣ  (he-IL-u-ca-hebrew-co-phonebk)  ޷ ü"
                );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ޷  ϱ - ReportCalendarData(calendar, calendarLabel)

        /// <summary>
        /// ޷  ϱ
        /// </summary>
        /// <param name="calendar">޷</param>
        /// <param name="calendarLabel">޷ ̺</param>
        /// <returns>޷ </returns>
        private string ReportCalendarData(Calendar calendar, string calendarLabel)
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{calendarLabel} : {calendar.GetCalendarSystem()}");
            stringBuilder.AppendLine($"޷ : {calendar.GetCalendarSystem()}");
            stringBuilder.AppendLine($" ý : {calendar.NumeralSystem}");
            stringBuilder.AppendLine($"  : {calendar.ResolvedLanguage}");
            stringBuilder.AppendLine($" : {calendar.YearAsString()}");
            stringBuilder.AppendLine($" : {calendar.MonthAsSoloString()}");
            stringBuilder.AppendLine($" : {calendar.DayAsPaddedString(2)}");
            stringBuilder.AppendLine($" : {calendar.DayOfWeekAsSoloString()}");
            stringBuilder.AppendLine();

            return stringBuilder.ToString();
        }

        #endregion
    }
}