using System.Text;
using Windows.Globalization;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///   5
    /// </summary>
    public sealed partial class SamplePage5 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SamplePage5()

        /// <summary>
        /// 
        /// </summary>
        public SamplePage5()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ǥ ư Ŭ óϱ - showResultButton_Click(sender, e)

        /// <summary>
        ///  ǥ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void showResultButton_Click(object sender, RoutedEventArgs e)
        {
            string[] timeZoneArray = new[] { "UTC", "America/New_York", "Asia/Kolkata" };

            StringBuilder stringBuilder = new StringBuilder();

            Calendar calendar = new Calendar();

            string localTimeZone = calendar.GetTimeZone();

            stringBuilder.AppendLine(" ¥  ð :");
            stringBuilder.AppendLine(ReportCalendarData(calendar));

            foreach(string timeZone in timeZoneArray)
            {
                calendar.ChangeTimeZone(timeZone);

                stringBuilder.AppendLine(ReportCalendarData(calendar));
            }

            stringBuilder.AppendLine();

            calendar.ChangeTimeZone(localTimeZone);

            stringBuilder.AppendLine(" 2 14  ð : ");

            calendar.AddYears(1);
            
            calendar.Month = 2;
            calendar.Day   = 14;

            stringBuilder.AppendLine(ReportCalendarData(calendar));

            foreach(string timeZone in timeZoneArray)
            {
                calendar.ChangeTimeZone(timeZone);

                stringBuilder.AppendLine(ReportCalendarData(calendar));
            }

            stringBuilder.AppendLine();

            calendar.ChangeTimeZone(localTimeZone);

            stringBuilder.AppendLine(" 10 14  ð : ");

            calendar.AddMonths(8);

            stringBuilder.AppendLine(ReportCalendarData(calendar));

            foreach(string timeZone in timeZoneArray)
            {
                calendar.ChangeTimeZone(timeZone);

                stringBuilder.AppendLine(ReportCalendarData(calendar));
            }

            stringBuilder.AppendLine();

            this.resultTextBlock.Text = stringBuilder.ToString();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ޷  ϱ - ReportCalendarData(calendar)

        /// <summary>
        /// ޷  ϱ
        /// </summary>
        /// <param name="calendar">޷</param>
        /// <returns>޷ </returns>
        private string ReportCalendarData(Calendar calendar)
        {
            return string.Format
            (
                "ð {0} : {1} {2} {3} {4} {5}:{6}:{7} {8} {9}",
                calendar.GetTimeZone(),
                calendar.YearAsString(),
                calendar.MonthAsSoloString(),
                calendar.DayAsPaddedString(2),
                calendar.DayOfWeekAsSoloString(),
                calendar.HourAsPaddedString(2),
                calendar.MinuteAsPaddedString(2),
                calendar.SecondAsPaddedString(2),
                calendar.PeriodAsString(),
                calendar.TimeZoneAsString(3)
            );
        }

        #endregion
    }
}