using System.Text;
using Windows.Globalization;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    ///   2
    /// </summary>
    public sealed partial class SamplePage2 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - SamplePage2()

        /// <summary>
        /// 
        /// </summary>
        public SamplePage2()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region  ǥ ư Ŭ óϱ - showResultButton_Click(sender, e)

        /// <summary>
        ///  ǥ ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void showResultButton_Click(object sender, RoutedEventArgs e)
        {
            Calendar calendar = new Calendar();

            Calendar japaneseCalendar = new Calendar
            (
                new[] { "ja-JP" },
                CalendarIdentifiers.Japanese,
                ClockIdentifiers.TwelveHour
            );

            Calendar hebrewCalendar = new Calendar
            (
                new[] { "he-IL" },
                CalendarIdentifiers.Hebrew,
                ClockIdentifiers.TwentyFourHour
            );

            this.resultTextBlock.Text = ReportCalendarData(calendar        , " Ʈ ޷ ý") +
                                        ReportCalendarData(japaneseCalendar, "޷ ý"              ) +
                                        ReportCalendarData(hebrewCalendar  , "޷ ý"              );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ޷  ϱ - ReportCalendarData(calendar, calendarLabel)

        /// <summary>
        /// ޷  ϱ
        /// </summary>
        /// <param name="calendar">޷</param>
        /// <param name="calendarLabel">޷ ̺</param>
        /// <returns>޷ </returns>
        private string ReportCalendarData(Calendar calendar, string calendarLabel)
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine($"{calendarLabel} : {calendar.GetCalendarSystem()}");
            stringBuilder.AppendLine($"    : {calendar.NumberOfMonthsInThisYear}");
            stringBuilder.AppendLine($"   : {calendar.NumberOfDaysInThisMonth}");
            stringBuilder.AppendLine($" Ⱓ ð : {calendar.NumberOfHoursInThisPeriod}");
            stringBuilder.AppendLine($" : {calendar.EraAsString()}");
            stringBuilder.AppendLine();

            return stringBuilder.ToString();
        }

        #endregion
    }
}